//---------------------------------------------------------------------------

#include <vcl.h>
#include <io.h>
#include <fcntl.h>
#pragma hdrstop

#include "LPT.h"
#include "Unit1.h"
#include "utilit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "TVICLPTLib_OCX"
#pragma resource "*.dfm"
TForm2 *Form2;
//---------------------------------------------------------------------------
int byteblaster_test()
{
 int err=0;

 Form2->TVicLPT1->DataPort=Form2->JTAG_out_state|0xa0;
 if((Form2->TVicLPT1->StatusPort&0x64)!=0x64) err++;

 Form2->TVicLPT1->DataPort=Form2->JTAG_out_state&(~0xa0);
 if((Form2->TVicLPT1->StatusPort&0x64)!=0x4) err++;

 return err;
}
int lpt_modes_search(int port_num)
{
  int mn,i=0;
  Form2->TVicLPT1->CurrentLPT=port_num;
  if((mn=Form2->TVicLPT1->MaxLptMode)==LPT_NOT_PRESENT)
   {
    Form1->Memo1->Lines->Add("LPT-port don't work!");
    Form2->TVicLPT1->Active=0;
    return 1;
   }
   else
   {
     if((mn == LPT_SPP_MODE) || (mn == LPT_ECP_MODE))
      {
       Form2->ListBox1->Items->Add("SPP");
       Form2->LPT_modes[i]=LPT_SPP_MODE;i++;
      }
     if((mn == LPT_PS2_MODE) || (mn == LPT_ECP_MODE))
      {
       Form2->ListBox1->Items->Add("PS2");
       Form2->LPT_modes[i]=LPT_PS2_MODE;i++;
      }
     if ((mn == LPT_EPP_MODE) || ((mn == LPT_ECP_MODE) && Form2->TVicLPT1->EPPEnabled))
      {
       Form2->ListBox1->Items->Add("EPP");
       Form2->LPT_modes[i]=LPT_EPP_MODE;i++;
      }
     if(mn == LPT_ECP_MODE)
      {
       Form2->ListBox1->Items->Add("FAST_CENTRONIX");
       Form2->LPT_modes[i]=LPT_FAST_CENTRONIX;i++;
       Form2->ListBox1->Items->Add("ECP");
       Form2->LPT_modes[i]=LPT_ECP_MODE;i++;
      }

     Form2->TVicLPT1->CurrentLptMode=Form2->LPT_modes[0];
     if(Form2->TVicLPT1->CurrentLptMode!=Form2->LPT_modes[0])
     {
       Form1->Memo1->Lines->Add("Can't set LPT mode!");
       Form2->TVicLPT1->Active=0;
     }
     Form2->ListBox1->ItemIndex=0;

   }
 return 0;
}

__fastcall TForm2::TForm2(TComponent* Owner)
        : TForm(Owner)
{
 int err=0,i;

 JTAG_out_state=0xff;

 TVicLPT1->Active=1;
 if(TVicLPT1->Active==0)TVicLPT1->Active=2;
 if(TVicLPT1->Active==0)Form1->Memo1->Lines->Add("Can't open LPT Driver!!! Setup TVicLPT!!!");
 else Form1->Memo1->Lines->Add("LPT Driver present.");

 if(TVicLPT1->NumLPTs==0)
  {
    Form1->Memo1->Lines->Add("LPT-port not present!");
    TVicLPT1->Active=0;
  }
 else
 {
  for(i=0;i<TVicLPT1->NumLPTs;i++)
   ListBox2->Items->Add(IntToStr(i+1));
  ListBox2->ItemIndex=0;
  err=lpt_modes_search(1);
 }

 if(err==0)Form1->Memo1->Lines->Add("LPT config done.");
 TVicLPT1->ControlPortBit[1]=1;

 err=byteblaster_test();

 if(err!=0)Form1->Memo1->Lines->Add("ByteBlasterMV not present!");
 else Form1->Memo1->Lines->Add("ByteBlasterMV present.");

}
//---------------------------------------------------------------------------

void __fastcall TForm2::Button1Click(TObject *Sender)
{
 TVicLPT1->Active=1;
 if(TVicLPT1->Active==0)TVicLPT1->Active=2;
 if(TVicLPT1->Active==0){Form1->Memo1->Lines->Add("Not open LPT Driver!!! Setup TVicLPT!!!");return;}
 if(TVicLPT1->CurrentLPT!=ListBox2->ItemIndex+1)lpt_modes_search(ListBox2->ItemIndex+1);
 else if(TVicLPT1->CurrentLptMode!=LPT_modes[ListBox1->ItemIndex])
 {
   Form2->TVicLPT1->CurrentLptMode=Form2->LPT_modes[ListBox1->ItemIndex];
   if(Form2->TVicLPT1->CurrentLptMode!=Form2->LPT_modes[ListBox1->ItemIndex])
     {
       Form1->Memo1->Lines->Add("Can't set LPT mode!");
       Form2->TVicLPT1->Active=0;
     }
   else Form1->Memo1->Lines->Add("LPT mode change.");
 }
}
//---------------------------------------------------------------------------

void __fastcall TForm2::Button3Click(TObject *Sender)
{
  if(byteblaster_test()==0)Form1->Memo1->Lines->Add("ByteBlasterMV present.");
  else Form1->Memo1->Lines->Add("ByteBlasterMV not present!");
}
//---------------------------------------------------------------------------
#define JTAGS_TCK 0x1
#define JTAGS_TMS 0x2
#define JTAGS_TDO 0x40
#define JTAG_COM_IDCODE 0xE
int __fastcall TForm2::TDI()
{
        //TVicLPT1->DataPort;
        if ((TVicLPT1->StatusPort & 0x80) != 0x80) return 1;
        else return 0;
	//return (TVicLPT1->StatusPort & 0x80) != 0x80;
}

void __fastcall TForm2::TCK(int x)
{
 unsigned int tmp=0;
   //while(tmp<1000)tmp++;
   if(x!=0) JTAG_out_state |= JTAGS_TCK;
   else JTAG_out_state &= ~JTAGS_TCK;
   TVicLPT1->DataPort=(JTAG_out_state)&0xff;
   tmp=0;
   //while(tmp<1000)tmp++;
}

void __fastcall TForm2::TCK_1_0()
{
/*
   state |=  _TCK; outport(oport, state);
   state &= ~_TCK; outport(oport, state);
*/
   int tmp=0;
   //while(tmp<1000)tmp++;
   TVicLPT1->DataPort=(JTAG_out_state|JTAGS_TCK)&0xff;/* ,      TCK=0*/
   tmp=0;
   //while(tmp<1000)tmp++;
   TVicLPT1->DataPort=(JTAG_out_state)&0xff;
   tmp=0;
   //while(tmp<1000)tmp++;

}

void __fastcall TForm2::TMS(int x)
{
	if(x!=0) JTAG_out_state |= JTAGS_TMS;
        else JTAG_out_state &= ~JTAGS_TMS;
        TVicLPT1->DataPort=(JTAG_out_state)&0xff;
}

void __fastcall TForm2::TDO(int x)
{
	if(x!=0) JTAG_out_state |= JTAGS_TDO;
        else JTAG_out_state &= ~JTAGS_TDO;
        TVicLPT1->DataPort=(JTAG_out_state)&0xff;
}


int __fastcall TForm2::JTAG_init()
{
 int i;
 if(TVicLPT1->Active==0){Form1->Memo1->Lines->Add("LPT-driver error!");return 1;}
 if(byteblaster_test()!=0){Form1->Memo1->Lines->Add("ByteBlasterMV error!");return 1;}

   TVicLPT1->DataPort=JTAG_out_state=0x0;
   //TVicLPT1->ControlPort=0xffff;

   TMS(1); /* Reset of controller JTAG interface */
   TCK(0);
   for(i=0; i<10; i++)
   {
        TCK_1_0();
   }
   TMS(0);
   TCK_1_0(); /* -> Run-Test/Idle */
   TMS(1);
   TCK_1_0(); /* -> Select-DR-Scan */
   return 0;
}

void __fastcall TForm2::JTAG_Command(int x)
{

   TMS(1); TCK_1_0(); /* -> Select-IR-Scan */
   TMS(0); TCK_1_0(); /* -> Capture-IR */
   /*  0*/ TCK_1_0();

   TDO(x&1); TCK_1_0();
   TDO(x&2); TCK_1_0();
   TDO(x&4); TCK_1_0();
		TMS(1); /* Prepare to break from loop */
   TDO(x&8); TCK_1_0();
   /*  1*/ TCK_1_0(); /* -> Update-IR      */
   /*  1*/ TCK_1_0(); /* -> Select-DR-Scan */
}

void __fastcall TForm2::JTAG_ExenData(unsigned char *p, int bits)
{
   TMS(0); TCK_1_0(); /* -> Capture-DR     */
   /*  0*/ TCK_1_0(); /* -> Shift-DR       */

   for(int i=0; i<(bits-1); i++) {
		TDO(*p); TCK(1); *p++ = TDI(); TCK(0);
   }
   TMS(1); /*  Prepare to break from loop + last bit */
   TDO(*p); TCK(1); *p = TDI(); TCK(0); /* -> Exit1-DR  */

   /*  1*/ TCK_1_0(); /* -> Update-DR */
   /*  1*/ TCK_1_0(); /* -> Select-DR-Scan */

}

void Prep_READ(unsigned char buf[], unsigned long x)
{

   buf[0]=1; // ABE=1
   for(int i=1;i<121;i++) buf[i]=0;
   buf[41]=0;  //nMREQ
   buf[55]=1; // Nenout
   buf[51]=buf[49]=buf[42]=buf[33]=1;

   for(int i=1; i<33; i++)
   {
   	buf[i]= x & 1;
   	x>>=1;
   }

}


//---------------------------------------------------------------------------
void __fastcall TForm2::Button4Click(TObject *Sender)
{
 unsigned char buf[32];
 unsigned int tmp,i;
 //for(i=0;i<32;i++)buf[i]=1;
  if(JTAG_init()!=0)return;
  JTAG_Command(0xE);
  JTAG_ExenData(buf, 32);
  tmp=deserial_revers(buf, 32);
  Form1->Memo1->Lines->Add("ID CODE is "+IntToHEXString(tmp));
}
//---------------------------------------------------------------------------

void __fastcall TForm2::Button2Click(TObject *Sender)
{
int hand;
unsigned int tmp,start=HEXStringToInt(Edit1->Text),count=HEXStringToInt(Edit2->Text);
unsigned char buf[128];
if(JTAG_init()!=0){Form1->Memo1->Lines->Add("JTAG error!");return;}
if(Form1->SaveDialog1->Execute())
{
  if((hand=_rtl_creat(Form1->SaveDialog1->FileName.c_str(),0))==-1){Form1->Memo1->Lines->Add("File error!");return;}

  JTAG_Command(0x3);  /* Load SAMPLE/PRELOAD */
  Prep_READ(buf,0L);
  JTAG_ExenData(buf, 121);
  JTAG_Command(0);  /* Load EXTEST */
  Prep_READ(buf,start);
  JTAG_ExenData(buf, 121);
  JTAG_Command(0);
  do{
        start+=4;
        count-=4;
        Prep_READ(buf,start);
        JTAG_ExenData(buf, 121);
        //tmp=deserial_direct_inc2(&buf[56],32);

        tmp=0;
	for(int i=58; i<121; i+=2) tmp+=buf[i] + tmp;

        tmp=revers_uint(tmp);
        _rtl_write(hand,&tmp,4);




  }while(count!=0);


  _rtl_close(hand);
}
}
//---------------------------------------------------------------------------

