#ifndef ARM3DO_HEADER
#define ARM3DO_HEADER

#define ARM3DO_DEBUG_MODE
#define ARM3DO_GPREGS_NUM 16
#define ARM3DO_NUM_OF_MODES 6

#define ARM3DO_MMASK_USER 0x10
#define ARM3DO_MMASK_FIQ 0x11
#define ARM3DO_MMASK_IRQ 0x12
#define ARM3DO_MMASK_SUPERVISOR 0x13
#define ARM3DO_MMASK_ABORT 0x17
#define ARM3DO_MMASK_UNDEFINED 0x1B
#define ARM3DO_MINDX_USER       0
#define ARM3DO_MINDX_FIQ        1
#define ARM3DO_MINDX_IRQ        2
#define ARM3DO_MINDX_SUPERVISOR 3
#define ARM3DO_MINDX_ABORT      4
#define ARM3DO_MINDX_UNDEFINED  5

#define ARM3DO_SETFLAG_FIQ      0x40
#define ARM3DO_SETFLAG_IRQ      0x80
#define ARM3DO_SETFLAG_OVER     0x10000000
#define ARM3DO_SETFLAG_CARR     0x20000000
#define ARM3DO_SETFLAG_ZERO     0x40000000
#define ARM3DO_SETFLAG_NEG      0x80000000

#define ARM3DO_COND_EQ 0x00
#define ARM3DO_COND_NE 0x01
#define ARM3DO_COND_CS 0x02
#define ARM3DO_COND_CC 0x03
#define ARM3DO_COND_MI 0x04
#define ARM3DO_COND_PL 0x05
#define ARM3DO_COND_VS 0x06
#define ARM3DO_COND_VC 0x07
#define ARM3DO_COND_HI 0x08
#define ARM3DO_COND_LS 0x09
#define ARM3DO_COND_GE 0x0a
#define ARM3DO_COND_LT 0x0b
#define ARM3DO_COND_GT 0x0c
#define ARM3DO_COND_LE 0x0d
#define ARM3DO_COND_AL 0x0e
#define ARM3DO_COND_NV 0x0f

#define  ARM3DO_NOP 0x00

#define ARM_DEBUG_PREANALISES 0      //  
#define ARM_DEBUG_POSTANALISES 3      //    
#define ARM_DEBUG_READ_OP_NOTALIGN 1      //    
#define ARM_DEBUG_READ_OP_OUTREGION 2     //    
#define ARM_DEBUG_WREXEPT_PSR_TO_PC 4   //       !
#define ARM_DEBUG_RDEXEPT_SPSR_USERM 5  //   SPSR   
#define ARM_DEBUG_WREXEPT_PC_TO_PSR 6   //   PSR    
#define ARM_DEBUG_WREXEPT_SPSR_USERM 7  //  SPSR   
#define ARM_DEBUG_WREXEPT_PC_TO_PSRF 8  //    PSR  PC

#define ARM_EXPLORE_PREANALISES 0
#define ARM_EXPLORE_POSTANALISES 0
#define ARM_EXPLORE_READ_OP_DRAM 1
#define ARM_EXPLORE_READ_OP_ROM 2

typedef unsigned char uchar;
typedef unsigned int uint32;

#define ARM3DO_CICLES_GETOPCODE    1

#define ARM3DO_INTR_MASK_MRS    0x0fbf0fff
#define ARM3DO_INTR_ID_MRS      0x010f0000
#define ARM3DO_INTR_MASK_MSR    0x0fbffff0
#define ARM3DO_INTR_ID_MSR      0x0129f000
#define ARM3DO_INTR_MASK_MSRF   0x0dbff000
#define ARM3DO_INTR_ID_MSRF     0x0128f000
#define ARM3DO_INTR_MASK_MULT   0x0fc000f0
#define ARM3DO_INTR_ID_MULT     0x00000090
#define ARM3DO_INTR_MASK_SDS    0x0fb00ff0
#define ARM3DO_INTR_ID_SDS      0x01000090






#endif